#include "pch.h"
#include "EaUser.h"
#include "MtConverter.h"

EA_USER::EA_USER()
{
		namelength = 0;
		expired = -1;
}

EA_USER::EA_USER(std::string name)
{
	unsigned int l = (unsigned int)name.length();
	if (l >= PRODMAXLENGTH)
		throw  std::overflow_error("name too long: " + name);
	namelength = l;
	char* a = eaname;
	for ( auto c : name) 
		*a++ = c;
	expired = -1;
}

EA_USER::EA_USER(EA_USER & eauser):expired(eauser.expired),namelength(eauser.namelength)
{
	memcpy(eaname, eauser.eaname, PRODMAXLENGTH);
}

std::string EA_USER::GetName()
{
	return (namelength == 0) ? std::string() :std::string(eaname, namelength);
}

void EA_USER::SetName(std::string newName)
{
	unsigned int l = (unsigned int)newName.length();
	if (l >= PRODMAXLENGTH)
		throw  std::overflow_error("name too long: " + newName);
	if (l > namelength) 
		namelength = l;
	char* a = eaname;
	for (auto c : newName)
		*a++ = c;
}

std::string EA_USER::GetTimeExpired()
{
	return MtConverter::ToString(expired);
}

std::string EA_USER::ToString()
{
	std::stringstream  ot;
	ot << " Name: " << GetName() << "  Expired: " << GetTimeExpired();
	return ot.str();
}

size_t EA_USER::ToArray(byte * pbyte)
{
	try {
		memcpy_s(pbyte, GetSize(), (byte*)this, GetSize());
	}
	catch (std::exception& e) {
		std::cout << __FUNCTION__ << " " << e.what() << '\n';
		throw;
	}

	return GetSize();
}

constexpr size_t EA_USER::GetSize() noexcept
{
	return sizeof(time_t) + sizeof(long) + PRODMAXLENGTH;
}

std::ostream& operator<< (std::ostream& out, EA_USER& eauser)
{
	try {
		out.write((const char*)(&eauser), sizeof(time_t) + sizeof(long) + PRODMAXLENGTH);
	} 	catch (std::exception& e) 	{
		std::cout << __FUNCTION__ << " " << e.what() << '\n';
		throw;
	}
	return out;
}

std::istream& operator>> (std::istream& in, EA_USER& eauser) {
	try {
		in.read((char*)(&eauser), sizeof(time_t) + sizeof(long) + PRODMAXLENGTH);
	} 	catch (std::exception& e) {
		std::cout << __FUNCTION__ << " " << e.what() << '\n';
		throw;
	}
	return in;
}
