#pragma once
#ifndef USERLIC_H
#define USERLIC_H


#include "EaUser.h"

constexpr size_t COUNTACC = 5;

#pragma pack(1)
typedef struct USER_LIC
{
	using PEAUNIC = std::unique_ptr<EAUSER>;

	USER_LIC();
	USER_LIC(USER_LIC&& ul);
	USER_LIC(const byte* pbyte);
	int64_t uid;                  
	std::time_t expired;       
	long log_count;             
	int64_t logins[COUNTACC];     
	long ea_count;             
	std::vector<PEAUNIC> pEa;

	std::string GetTimeExpired();
	std::string ToString();
	size_t ToArray(byte* pbyte);
	void AddEA(EA_USER eau);
	bool AddAcc(long newAcc);
	size_t GetSize();

	friend std::ostream& operator<< (std::ostream& out, USER_LIC& ul);
	friend std::istream& operator>> (std::istream& in, USER_LIC& ul);

	USER_LIC& operator=(const USER_LIC&) = delete;
	USER_LIC(const USER_LIC&) = delete;
} USERLIC, *PUSERLIC;
#pragma pack()

#endif

